
var config = require('./config/config.json'),
	cmd = require('node-cmd'),
	fs = require('fs');

function HotSpotControl(){
};

HotSpotControl.prototype.createHotSpot = function(callback){
	hs.writeConfig();
//	hs.writeStatus();
	cmd.get(
		'netsh wlan set hostednetwork mode=allow ssid=' + config.ssid + ' key=' + config.key,
		function(data){
			console.log('createHotSpot: ', data);

			callback && callback(data);
	});
};

HotSpotControl.prototype.startHotSpot = function(callback){
	cmd.get('netsh wlan start hostednetwork', function(data){
		console.log('startHotSpot: ', data);
		callback && callback(data);
	}); 
};

HotSpotControl.prototype.stopHotSpot = function(callback){
	cmd.get('netsh wlan stop hostednetwork', function(data){
		console.log('stopHotSpot: ', data);
		callback && callback(data);
	}); 
};

HotSpotControl.prototype.showHotSpot = function(callback){
	cmd.get('netsh wlan show hostednetwork', function(data){
		console.log('showHotSpot: ', data);
		hs.netshParser(data, function(data){
			callback && callback(data);
		});
	});
};

HotSpotControl.prototype.enableInternetConnectionShare = function(callback){
	cmd.get('netsh wlan show hostednetwork', function(data){
		console.log('Enable Internet Connection Share: ', data);
		callback && callback(data);
	});
};

HotSpotControl.prototype.netshParser = function(str, callback){
	var arr = str.split('\r\n');
//	var conf;
	var json;
	var obj = new Object();
	obj.Authenticated = [];
	for(var i = 0; i < arr.length; i++){
		if((arr[i].split(':')).length > 1){
			var s;
			s = arr[i].replace(/[\s\"]+/g, '');
			if(s.match(/Authenticated/g)){
				s = s.replace(/Authenticated/g, '');
				obj.Authenticated.push(s);
			}
			else{
				s = s.replace(/:/i,'$').split('$');
				obj[s[0]] = s[1];
			}
		}
	}
	json = JSON.stringify(obj, null, '\t');
	hs.writeStatus(json);
	callback && callback(json);
};

HotSpotControl.prototype.writeStatus = function(data){
	fs.writeFile('../config/status.json', data, function(err){
		if(err) throw err;
	});
};

HotSpotControl.prototype.getHostName = function(callback){
	cmd.get('hostname', function(data){
		callback && callback(data);
	});
};

HotSpotControl.prototype.writeConfig = function(){
	fs.readFile('../config/config.json', function(err, data){
		var config;
		if(err){
			console.error(err);
		} else {
			config = JSON.parse(data);
			hs.getHostName(function(data){
				data = data.replace(/\r\n/, '');
				config.ssid = data;
				fs.writeFile('../config/config.json', JSON.stringify(config, null, '\t'), function(err){
					if(err) throw err;
				});
			});
		}
	});
};

HotSpotControl.prototype.showStatus = function(callback){
	fs.readFile('../config/status.json', function(err, data){
		if(err){
			console.log(err);
		} else {
			callback && callback(JSON.stringify(JSON.parse(data), null, '\t'));
		}
	});
};

var hs = new HotSpotControl();
hs.writeConfig();
exports.HotSpotControl = HotSpotControl;
