var cmd = require('node-cmd'),
	config = require('../config/config.json'),
	http = require('http'),
    fs = require('fs');
var hotSpotControl = require('../hotspot-control.js');
var hs = new hotSpotControl.HotSpotControl();

var app = http.createServer(function (request, response) {
	fs.readFile("../client/index.html", 'utf-8', function (error, data) {
		response.writeHead(200, {'Content-Type': 'text/html'});
		response.write(data);
		response.end();
	});
}).listen(1337);
 
var io = require('socket.io').listen(app);
io.sockets.on('connection', function(socket) {
	socket.on('message_to_server', function(data) {
		io.sockets.emit("message_to_client",{ message: data["message"] });
	});

	socket.on('create_hotspot',function (){
		hs.createHotSpot(function(data){
			io.sockets.emit("message_to_client",{ message: data});
			/*hs.startHotSpot(function(data){
				io.sockets.emit("message_to_client",{ message: data});
			});*/
		});
	});

	socket.on('start_hotspot',function (){
		hs.startHotSpot(function(data){
			io.sockets.emit("message_to_client",{ message: data});
		});
	});

	socket.on('stop_hotspot',function (){
		hs.stopHotSpot(function(data){
			io.sockets.emit("message_to_client",{ message: data});
		});
	});

	socket.on('show_hotspot', function(){
		hs.showHotSpot(function(data){
			io.sockets.emit("message_to_client",{ message: data});
		});
	});
	
	socket.on('enable_ics',function (){
		hs.enableInternetConnectionShare(function(data){
			io.sockets.emit("message_to_client",{ message: data});
		});
	});

});